/* -*- Mode: C; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is Mozilla Communicator client code, released
 * March 31, 1998.
 *
 * The Initial Developer of the Original Code is Michael Hearn. Portions 
 * created by Netscape are Copyright (C) 1998-1999 Netscape Communications Corporation. 
 * All Rights Reserved.
 *
 * Contributor(s):
 *   Michael Hearn (mhearn@subdimension.com)
 */

var gProfileManagerBundle;
var currentProfile;
var profilePasswordRes = {}
var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);

function profilePasswordOKFunc() {
	pass = profilePasswordGetPassword(currentProfile);
	passInput = document.getElementById("pass.txt");
	if (pass != calcSHA1(passInput.value)) {
		profilePasswordRes.res = "invalid";
	} else {
		profilePasswordRes.res = "ok";
	}
	return true;
}

function profilePasswordCancelFunc() {
	profilePasswordRes.res = "cancel";
	return true;
}


// OnLoad for the password prompt window
function profilePasswordOnLoad() {
	// just init some vars for now
	dump("profilePasswordOnLoad() 1\n");
	profilePasswordRes = window.arguments[1];
	gProfileManagerBundle = document.getElementById("bundle_profileManager");
	if (window.arguments[0] == undefined) {
		var profile = Components.classes["@mozilla.org/profile/manager;1"].getService();
    if (profile) profile  = profile.QueryInterface(Components.interfaces.nsIProfileInternal);
		currentProfile = profile.currentProfile;
	} else {
		currentProfile = window.arguments[0];
	}

	pass = profilePasswordGetPassword(currentProfile);
	
	if (pass == undefined) {
		profilePasswordRes.res = "nopass";
		window.close(); // no password so close and go ahead
	}
	
	doSetOKCancel(profilePasswordOKFunc, profilePasswordCancelFunc);
	
	document.getElementById("pass.txt").focus();
}

// **************************************************************************************

function profilePasswordGetPassword(userprofile) {
	try {
		// get the directory service so we can get the directory in which the registry is stored
		var dirServ = Components.classes['@mozilla.org/file/directory_service;1'].createInstance();
		dirServ = dirServ.QueryInterface(Components.interfaces.nsIProperties);

		var regFile = dirServ.get("AppRegF", Components.interfaces.nsIFile);

		// initialise the registry service
		Registry = Components.classes['@mozilla.org/registry;1'].createInstance();
		Registry = Registry.QueryInterface(Components.interfaces.nsIRegistry);
		Registry.open(regFile.path); // open the registry
		profileRoot = Registry.getKey(Registry.Common, "Profiles");
		profileRoot = Registry.getKey(profileRoot,userprofile);	
		pass = Registry.getString(profileRoot, "password");
	} catch(e) {
		pass = undefined;
	}
	return pass;
}

function profilePasswordSetPassword(userprofile, password) {
	if (password == "") {
		throw Components.Exceptions("Password must be non-null");
	}
	
	// get the directory service so we can get the directory in which the registry is stored
	var dirServ = Components.classes['@mozilla.org/file/directory_service;1'].createInstance();
	dirServ = dirServ.QueryInterface(Components.interfaces.nsIProperties);

	var regFile = dirServ.get("AppRegF", Components.interfaces.nsIFile);

	// initialise the registry service
	Registry = Components.classes['@mozilla.org/registry;1'].createInstance();
	Registry = Registry.QueryInterface(Components.interfaces.nsIRegistry);
	Registry.open(regFile.path); // open the registry
	
	var profileRoot = Registry.getKey(Registry.Common, "Profiles");
	profileRoot = Registry.getKey(profileRoot,userprofile);
	
	sha1 = calcSHA1(password); // calculate digest of password
	Registry.setString(profileRoot, "password", sha1);
}

function profilePasswordRemove(userprofile) {
	// get the directory service so we can get the directory in which the registry is stored
	var dirServ = Components.classes['@mozilla.org/file/directory_service;1'].createInstance();
	dirServ = dirServ.QueryInterface(Components.interfaces.nsIProperties);

	var regFile = dirServ.get("AppRegF", Components.interfaces.nsIFile);

	// initialise the registry service
	Registry = Components.classes['@mozilla.org/registry;1'].createInstance();
	Registry = Registry.QueryInterface(Components.interfaces.nsIRegistry);
	Registry.open(regFile.path); // open the registry

	try {
	  var profileRoot = Registry.getKey(Registry.Common, "Profiles");
	  profileRoot = Registry.getKey(profileRoot,userprofile);
	  Registry.deleteValue(profileRoot,"password");
	} catch(e) {
		dump(e);
	}
}

function profilePasswordValidate(pass) {
	// We only reject passwords that have spaces in them for now
	if (pass.indexOf(" ") != -1) {
		return false;
	} else if (pass == "") {
		return false;
	}
	
	return true;
}


// ***************************************************************************************

// OnLoad for the SetPassword dialog
function profilePasswordDlgOnLoad() {
	gProfileManagerBundle = document.getElementById("bundle_profileManager");
	if (profilePasswordGetPassword(window.arguments[0]) == undefined) {
		document.getElementById("removeBtn").setAttribute("disabled","true");
	}
}

// handler for the Set Password button
function profilePasswordSetButton() {
	// ensure same password is entered twice
	if (document.getElementById("password1.txt").value != document.getElementById("password2.txt").value) {
		alert(gProfileManagerBundle.getString("profilePasswordMismatch"));
		return;
	}
	
	// ensure new password is valid
	if (profilePasswordValidate(document.getElementById("password1.txt").value) == false) {
		alert(gProfileManagerBundle.getString("profilePasswordInvalid"));
		return;
	}
	
	// attempt to set password
	try {
		profilePasswordSetPassword(window.arguments[0],document.getElementById("password1.txt").value);
		alert(gProfileManagerBundle.getString("profilePasswordSetOK"));
		window.close();
	} catch(e) {
		dump(e);
		alert(gProfileManagerBundle.getString("profilePasswordSetError"));
	}
}

function profilePasswordRemoveButton() {
	var title = gProfileManagerBundle.getString("profilePasswordRemoveTitle");
	var string = gProfileManagerBundle.getString("profilePasswordRemove");
	if (promptService.confirm(window,title,string)) {
		profilePasswordRemove(window.arguments[0]);
		window.close();
	} else { 
		return;
	}
}

// ****************************************************************************
// DEBUG
function debug(aText)
{
  var csClass = Components.classes['@mozilla.org/consoleservice;1'];
  var cs = csClass.getService(Components.interfaces.nsIConsoleService);
  cs.logStringMessage(aText);
}


// ****************************************************************************
// ****************************************************************************

/*
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
 * in FIPS PUB 180-1
 * Copyright (C) Paul Johnston 2000.
 * See http://pajhome.org.uk/site/legal.html for details.
 */

/*
 * Convert a 32-bit number to a hex string with ms-byte first
 */
var hex_chr = "0123456789abcdef";
function hex(num)
{
  var str = "";
  for(var j = 7; j >= 0; j--)
    str += hex_chr.charAt((num >> (j * 4)) & 0x0F);
  return str;
}

/*
 * Convert a string to a sequence of 16-word blocks, stored as an array.
 * Append padding bits and the length, as described in the SHA1 standard.
 */
function str2blks_SHA1(str)
{
  var nblk = ((str.length + 8) >> 6) + 1;
  var blks = new Array(nblk * 16);
  for(var i = 0; i < nblk * 16; i++) blks[i] = 0;
  for(i = 0; i < str.length; i++)
    blks[i >> 2] |= str.charCodeAt(i) << (24 - (i % 4) * 8);
  blks[i >> 2] |= 0x80 << (24 - (i % 4) * 8);
  blks[nblk * 16 - 1] = str.length * 8;
  return blks;
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally 
 * to work around bugs in some JS interpreters.
 */
function add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left
 */
function rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

/*
 * Perform the appropriate triplet combination function for the current
 * iteration
 */
function ft(t, b, c, d)
{
  if(t < 20) return (b & c) | ((~b) & d);
  if(t < 40) return b ^ c ^ d;
  if(t < 60) return (b & c) | (b & d) | (c & d);
  return b ^ c ^ d;
}

/*
 * Determine the appropriate additive constant for the current iteration
 */
function kt(t)
{
  return (t < 20) ?  1518500249 : (t < 40) ?  1859775393 :
         (t < 60) ? -1894007588 : -899497514;
}

/*
 * Take a string and return the hex representation of its SHA-1.
 */
function calcSHA1(str)
{
  var x = str2blks_SHA1(str);
  var w = new Array(80);

  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;
  var e = -1009589776;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;
    var olde = e;

    for(var j = 0; j < 80; j++)
    {
      if(j < 16) w[j] = x[i + j];
      else w[j] = rol(w[j-3] ^ w[j-8] ^ w[j-14] ^ w[j-16], 1);
      t = add(add(rol(a, 5), ft(j, b, c, d)), add(add(e, w[j]), kt(j)));
      e = d;
      d = c;
      c = rol(b, 30);
      b = a;
      a = t;
    }

    a = add(a, olda);
    b = add(b, oldb);
    c = add(c, oldc);
    d = add(d, oldd);
    e = add(e, olde);
  }
  return hex(a) + hex(b) + hex(c) + hex(d) + hex(e);
}
